% zyx euler -- roll pitch yaw angles

syms sr cr sp cp sy cy


Rx = [ 1   0   0 ;  0   cr  -sr ;  0  sr  cr ];
Ry = [ cp  0  sp ;  0    1    0 ; -sp  0  cp ];
Rz = [ cy -sy  0 ; sy   cy    0 ;  0   0   1 ];

R = Rz * Ry * Rx;

cth = (trace(R) - 1)/2;
wprime = [ R(3,2) - R(2,3); R(1,3) - R(3,1); R(2,1) - R(1,2) ];
wcoeff = 1/(2*sqrt(1-cth*cth));
w = wcoeff * wprime;
