% zyz euler angles for flipped pen
% Correspond to slightly modified altitude, azimuth, and twist angles
% from wintab

syms st ct sz cz sa ca


Raz_z = [ cz -sz  0 ; sz   cz    0 ;  0   0   1 ];
Ral_y = [ ca  0  sa ;  0    1    0 ; -sa  0  ca ];
Rtw_z = [ ct -st  0 ; st   ct    0 ;  0   0   1 ];

roty180 = [ -1 0 0; 0 1 0; 0 0 -1 ];

R = roty180 * Raz_z * Ral_y * Raz_z.' * Rtw_z;
%R =  Raz_z * Ral_y * Raz_z.' * Rtw_z;

cth = (trace(R) - 1)/2; wprime = [ R(3,2) - R(2,3); R(1,3) - R(3,1);
R(2,1) - R(1,2) ]; 
wcoeff = 1/(2*sqrt(1-cth*cth)); 
w = wcoeff * wprime;


%R =
% 
%[ (-cz^2*ca-sz^2)*ct+(-cz*ca*sz+sz*cz)*st, -(-cz^2*ca-sz^2)*st+(-cz*ca*sz+sz*cz)*ct,  -cz*sa]
%[   (cz*ca*sz-sz*cz)*ct+(sz^2*ca+cz^2)*st,   -(cz*ca*sz-sz*cz)*st+(sz^2*ca+cz^2)*ct,  sz*sa]
%[                       cz*sa*ct+sz*sa*st,                       -cz*sa*st+sz*sa*ct,    -ca]

tr = R(1,1) + R(2,2) + R(3,3);
% tr = (-2*cz*ca*sz+2*sz*cz)*st+(-cz^2*ca-sz^2)*ct+(sz^2*ca+cz^2)*ct-ca
trp = (1-ca)* ( 2*sz*cz*st + (cz^2-sz^2)*ct ) - ca
 
r32mr23 = R(3,2)-R(2,3);
r32mr23p = (-st*cz+sz*ct -sz)*sa;

r21mr12 = R(2,1)-R(1,2);
r21mr12p = (ca-1)*(2*ct*sz*cz+st*sz^2-st*cz^2) ;
r21mr12p = (1-ca)*( -(2*sz*cz)*ct + (cz^2 - sz^2)*st ) ;

r13mr31 = R(1,3)-R(3,1);
r13mr31p = -sa*(cz + ct*cz + sz*st);


